#include	<stddef.h>
#include	<ctype.h>
#include	<stdio.h>
#include	<stdlib.h>
#include	<string.h>

#include	"mckc.h"

extern void splitPath( char *ptr, char *path, char *name, char *ext );
extern void makePath(  char *ptr, char *path, char *name, char *ext );
extern char *skipSpace( char *ptr );
extern char *patchstr;
extern char *hogereleasestr;

char	fname[2][256];
int		debug_flag = 0;
char	ef_name[256]  = "effect.h";
char	inc_name[256] = "define.inc";
int		warning_flag = 1;
int		include_flag = 0;
extern	int data_make( void );
extern	int		message_flag;			// ɽåν( 0:Jp 1:En )

/*--------------------------------------------------------------
	إɽ
 Input:

 Output:

--------------------------------------------------------------*/
void dispHelpMessage( void )
{
	if( message_flag == 0 ) {
#ifdef __MINGW32__
		puts(	"ˡ:mckc [switch] <Input File[.MUS]> [<Output File[.h]>]\n"
				"\t[switch]\n"
				"\t-h -?   : إפɽ\\n"
				"\t-i      : /٥ץե˶ʥǡɲä\n"
				"\t-m<num> : 顼/˥ɽ\(0:Jp 1:En)\n"
				"\t-n      : /٥ץեϤʤ\n"
				"\t-o<str> : /٥ץեΥե̾<str>ˤ\n"
				"\t-w      : Warningåɽ\ޤ\n"
	    );
#else
		puts(	"ˡ:mckc [switch] <Input File[.MUS]> [<Output File[.h]>]\n"
				"\t[switch]\n"
				"\t-h -?   : إפɽ\n"
				"\t-i      : /٥ץե˶ʥǡɲä\n"
				"\t-m<num> : 顼/˥ɽ(0:Jp 1:En)\n"
				"\t-n      : /٥ץեϤʤ\n"
				"\t-o<str> : /٥ץեΥե̾<str>ˤ\n"
				"\t-w      : Warningåɽޤ\n"
	    );
#endif

	} else {
		puts(	"usage:mckc [switch] <Input File[.MUS]> [<Output File[.h]>]\n"
				"\t[switch]\n"
				"\t-h -?   : Disp this help message\n"
				"\t-i      : Including song data in tone/envelope file\n"
				"\t-m<num> : Disp languege select Error/Warning message(0:Jp 1:En)\n"
				"\t-n      : Don't output tone/envelope file\n"
				"\t-o<str> : Output tone/Envelope file name is <str>\n"
				"\t-w      : Don't disp Warning message\n"
	    );
	}
	exit( 1 );
}



/*--------------------------------------------------------------
	ᥤ롼
 Input:
	int  argc		: ޥɥ饤θĿ
	char *argv[]	: ޥɥ饤Υݥ
 Output:
	0:ｪλ 0:ʳʾ彪λ
--------------------------------------------------------------*/
int main( int argc , char *argv[] )
{
	int	i,in,out;
	char	path[256],name[256],ext[256];

	in = out = 0;

// ȥɽ
	printf( "MML to MCK Data Converter Ver %d.%02d by Manbow-J\npmck modification by BKC rel 0.2\n",
			(VersionNo/100), (VersionNo%100) );
	//printf("patches by [OK] and 2ch mck thread people\n");
	printf(patchstr);
	printf(hogereleasestr);
// ޥɥ饤
	if( strlen(argv[0]) >2 && !strcmp( argv[0] + strlen(argv[0]) -2 ,"_e" ) )
		message_flag = 1;
	if( argc == 1 ) {
		dispHelpMessage();
		return -1;
	}

	for ( i = 1; i < argc; i++ ) {
		// å
		if ( (argv[i][0] == '-') || (argv[i][0] == '/') ) {
			switch( toupper( argv[i][1] ) ) {
			  case 'H':
			  case '?':
				dispHelpMessage();
				return 1;
			  case 'X':
				debug_flag = 1;
				break;
			  case 'I':
				include_flag = 1;
				break;
			  case 'M':
				message_flag = atoi( &(argv[i][2]) );
				if( message_flag > 1 ) {
					dispHelpMessage();
					return 1;
				}
				break;
			  case 'N':
				//obsolete
				break;
			  case 'O':
				strcpy( ef_name, skipSpace( &(argv[i][2]) ) );
				break;
			  case 'W':
				warning_flag = 0;
				break;
			  default:
				if( message_flag == 0 ) {
					puts( "åλ꤬㤤ޤ\n" );
				} else {
					puts( "Nothing switch!\n" );
				}
				dispHelpMessage();
				return -1;
			}
		// /ϥեγǼ
		} else {
			if( in < _num ) {
				strcpy( fname[in], argv[i] );
				in++;
			} else {
				if( message_flag == 0 ) {
					puts( "ѥ᡼¿ޤ\n" );
				} else {
					puts( "Too many parameters!\n" );
				}
				dispHelpMessage();
				return -1;
			}
		}
	}

	switch( in ) {
	  case 0:
		dispHelpMessage();
		return -1;
	  case 1:
		splitPath( fname[0], path, name, ext );
		makePath(  fname[1], path, name, ".h" );
		break;
	}

	printf( "%s -> %s\n" , fname[0], fname[1] );
// С
	i = data_make();
// λ
	if (i == 0) {
		if( message_flag == 0 ) {
			puts( "\nλޤ\n" );
		} else {
			puts( "\nCompleated!\n" );
		}
		return EXIT_SUCCESS;
	} else {
		if( message_flag == 0 ) {
			puts( "\nѥ˼Ԥޤ\n" );
		} else {
			puts( "\nCompilation failed!\n" );
		}
		return EXIT_FAILURE;
	}
}
